<?php

###############################################################################
#                                                                             #
#                          ICQ-                     #
#                         2007(C)Sax-mmS, icq: 272727765                      #
#                                                                             #
###############################################################################

  require_once('tpl.php');

  $SortTypeDef = array ('uin', 'state', 'cost');
  $SortDirectionDef = array ('ascending', 'descending');
    
  $digsName = array(
    4 => ' ',
    5 => '5- ',
    6 => '6- ',
    7 => '7- ',
    8 => '8- ',
    9 => '9- ',
  );
  
  ##############################################################################
  ##                                                    ##
  ##############################################################################

  function GetDigs()
  {
    global $digsName;
    
    $x = 4;
    if (isset($_GET['digs'])) 
    {
      $x = $_GET['digs'];
    }
    elseif (isset($_POST['digs'])) 
    {
      $x = $_POST['digs'];
    }

    if (isset($digsName[$x])) 
    {
      return $x;
    }
    else 
    {
      return 4;
    }
  }
  
  function GetPage()
  {
    $page = '';
    if (isset($_GET['digs'])) 
    {
      $page = $_GET['page'];
    }
    elseif (isset($_POST['digs'])) 
    {
      $page = $_POST['page'];
      if (!($page)) $page = 'main';
    }

    if (!($page)) $page = 'main';
    return $page;
  }

  
  function GetSortType()
  {
    global $SortTypeDef;
    
    if (!(isset($_GET['sort']))) 
    {
      return $SortTypeDef[2];
    }
    else
    {
      return $_GET['sort'];
    }
  }

  function GetSortDirection()
  {
    global $SortDirectionDef;
    
    if (!(isset($_GET['direction']))) 
    {
      return $SortDirectionDef[1];
    }
    else
    {
      return $_GET['direction'];
    }
  }
  
  ##############################################################################
  ##                                                  ##
  ##############################################################################
  
  function SaveNumbersToRAW($digs, $numbase)
  {
    $file = './icq/'.$digs.'.txt';
  
    $file = fopen($file, 'w+') or die('');
    flock($file, LOCK_EX);
      
    $numbers = array();                               
    $numbers = explode("\r\n", $numbase);
    
    foreach ($numbers as $k => $v)
    {
      //if ($v !== '') fputs($file, $k.' = '.$v."\r\n");
      if ($v !== '') 
      {
        if ($k != count($numbers)-1) fputs($file, $v."\r\n");
        else fputs($file, $v);
      }
    }
     
    flock($file, LOCK_UN);
    fclose($file);
  }

  ##############################################################################
  ##                                        ##
  ##############################################################################
  
  function NumbersToHTML($digs, $sort, $direction)
  {
    global $tplList;
    $content = '';
      
      $numbers = new TNumberList($sort, $direction);
      $numbers->FileName = './icq/'.$digs.'.txt';
      $numbers->LoadFromFile();
      $numbers->Sort();
  
      $trIndexStyle = '';
      $i = 0;
      foreach ($numbers->Data as $k => $v)
      {
        (($i % 2) == 1) ? $trIndexStyle = 'trNumOdd' : $trIndexStyle = 'trNumSec' ;
    
        $content .= "<tr class=\"".$trIndexStyle."\"><td class=\"tdNumUin\" colspan=\"2\">";
        $content .= $v['uin'];
        $content .= "</td><td class=\"tdNumState\" colspan=\"2\">";
        $content .= $v['state'];
        $content .= "</td><td class=\"tdNumCost\" colspan=\"2\">";
        $content .= $v['cost'];
        $content .= "</td></tr>";

        $i++;
      }
  
      $content = str_tpl('content', $content, $tplList['nums']);
      $digsPath = '?page=nums&digs='.$digs.'&';
  
      switch ($sort) 
      {
        case 'uin':
        {
          ($direction === 'ascending') ? $tdNumUinImg ='asc' : $tdNumUinImg ='desc';
          $tdNumStateImg ='blank';
          $tdNumCostImg  ='blank';
         
          ($direction === 'ascending') ? $tdNumUinLink = $digsPath.'sort=uin&direction=descending' : $tdNumUinLink =$digsPath.'sort=uin&direction=ascending';
          $tdNumStateLink = $digsPath.'sort=state&direction=ascending';
          $tdNumCostLink  = $digsPath.'sort=cost&direction=ascending';
      
          break; 
        }
        case 'state':
        {
          ($direction === 'ascending') ? $tdNumStateImg ='asc' : $tdNumStateImg ='desc';
          $tdNumUinImg  ='blank';
          $tdNumCostImg ='blank';
     
          ($direction === 'ascending') ? $tdNumStateLink =$digsPath.'sort=state&direction=descending' : $tdNumStateLink =$digsPath.'sort=state&direction=ascending';
          $tdNumUinLink   = $digsPath.'sort=uin&direction=ascending';
          $tdNumCostLink  = $digsPath.'sort=cost&direction=ascending';

          break; 
        }
        case 'cost':
        {
          ($direction === 'ascending') ? $tdNumCostImg ='asc' : $tdNumCostImg ='desc';
          $tdNumStateImg ='blank';
          $tdNumUinImg   ='blank';
     
          ($direction === 'ascending') ? $tdNumCostLink =$digsPath.'sort=cost&direction=descending' : $tdNumCostLink =$digsPath.'sort=cost&direction=ascending';
          $tdNumUinLink   = $digsPath.'sort=uin&direction=ascending';
          $tdNumStateLink = $digsPath.'sort=state&direction=ascending';

          break; 
        }
      }
  
      $content = str_tpl('tdNumUinImg',   HtmlSpecialChars($tdNumUinImg),   $content);
      $content = str_tpl('tdNumStateImg', HtmlSpecialChars($tdNumStateImg), $content);
      $content = str_tpl('tdNumCostImg',  HtmlSpecialChars($tdNumCostImg),  $content);
  
      $content = str_tpl('tdNumUinLink',  HtmlSpecialChars($tdNumUinLink),  $content);
      $content = str_tpl('tdNumStateLink',HtmlSpecialChars($tdNumStateLink),$content);
      $content = str_tpl('tdNumCostLink', HtmlSpecialChars($tdNumCostLink), $content);
  
      unset($numbers);
  
    return $content;      
  } // function NumbersToHTML
  
  ##############################################################################
  ##                                        ##
  ##############################################################################
  
  /*
  function NumbersToRAW($digs, $sort, $direction)
  {
    $content = '';
      
    $numbers = new TNumberList($sort, $direction);
    $numbers->FileName = './icq/'.$digs.'.txt';
    $numbers->LoadFromFile();
    $numbers->Sort();
  
    foreach ($numbers->Data as $k => $v)
    {
      $content .= $v['uin'].';'.$v['state'].';'.$v['cost'];
    }
  
    unset($numbers);
    
    return $content;      
  } // function NumbersToRAW 
  */
  
  function NumbersToRAW($digs, $sort, $direction)
  {
    global $tplList;
      
      $numbers = new TNumberList($sort, $direction);
      $numbers->FileName = './icq/'.$digs.'.txt';
      $numbers->LoadFromFile();
      $numbers->Sort();
  
      $content = '';
        
      foreach ($numbers->Data as $k => $v)
      {
        $content .= $v['uin'].';'.$v['state'].';'.$v['cost'];
      }
        
      $content = str_tpl('content', $content, $tplList['nums_editor']);
      $digsPath = '?page=nums&digs='.$digs.'&';
  
      switch ($sort) 
      {
        case 'uin':
        {
          ($direction === 'ascending') ? $tdNumUinImg ='asc' : $tdNumUinImg ='desc';
          $tdNumStateImg ='blank';
          $tdNumCostImg  ='blank';
         
          ($direction === 'ascending') ? $tdNumUinLink = $digsPath.'sort=uin&direction=descending' : $tdNumUinLink =$digsPath.'sort=uin&direction=ascending';
          $tdNumStateLink = $digsPath.'sort=state&direction=ascending';
          $tdNumCostLink  = $digsPath.'sort=cost&direction=ascending';
      
          break; 
        }
        case 'state':
        {
          ($direction === 'ascending') ? $tdNumStateImg ='asc' : $tdNumStateImg ='desc';
          $tdNumUinImg  ='blank';
          $tdNumCostImg ='blank';
     
          ($direction === 'ascending') ? $tdNumStateLink =$digsPath.'sort=state&direction=descending' : $tdNumStateLink =$digsPath.'sort=state&direction=ascending';
          $tdNumUinLink   = $digsPath.'sort=uin&direction=ascending';
          $tdNumCostLink  = $digsPath.'sort=cost&direction=ascending';

          break; 
        }
        case 'cost':
        {
          ($direction === 'ascending') ? $tdNumCostImg ='asc' : $tdNumCostImg ='desc';
          $tdNumStateImg ='blank';
          $tdNumUinImg   ='blank';
     
          ($direction === 'ascending') ? $tdNumCostLink =$digsPath.'sort=cost&direction=descending' : $tdNumCostLink =$digsPath.'sort=cost&direction=ascending';
          $tdNumUinLink   = $digsPath.'sort=uin&direction=ascending';
          $tdNumStateLink = $digsPath.'sort=state&direction=ascending';

          break; 
        }
      }
  
      $content = str_tpl('tdNumUinImg',   HtmlSpecialChars($tdNumUinImg),   $content);
      $content = str_tpl('tdNumStateImg', HtmlSpecialChars($tdNumStateImg), $content);
      $content = str_tpl('tdNumCostImg',  HtmlSpecialChars($tdNumCostImg),  $content);
  
      $content = str_tpl('tdNumUinLink',  HtmlSpecialChars($tdNumUinLink),  $content);
      $content = str_tpl('tdNumStateLink',HtmlSpecialChars($tdNumStateLink),$content);
      $content = str_tpl('tdNumCostLink', HtmlSpecialChars($tdNumCostLink), $content);
  
      unset($numbers);
  
    return $content;      
  } // function NumbersToHTML  
  
  ##############################################################################
  ##                               ##
  ##############################################################################  
  
  function CompareNumberUIN_A($a, $b) 
  {
      if ($a['uin'] == $b['uin']) {
          return 0;
      }
      return ($a['uin'] > $b['uin']) ? 1 : -1;
  }  
  
  function CompareNumberSTATE_A($a, $b) 
  {
      if ($a['state'] == $b['state']) {
          return 0;
      }
      return ($a['state'] > $b['state']) ? 1 : -1;
  }  

  function CompareNumberCOST_A($a, $b) 
  {
      if ($a['cost'] == $b['cost']) {
          return 0;
      }
      return ($a['cost'] > $b['cost']) ? 1 : -1;
  }  

  function CompareNumberUIN_D($a, $b) 
  {
      if ($a['uin'] == $b['uin']) {
          return 0;
      }
      return ($a['uin'] > $b['uin']) ? -1 : 1;
  }  
  
  function CompareNumberSTATE_D($a, $b) 
  {
      if ($a['state'] == $b['state']) {
          return 0;
      }
      return ($a['state'] > $b['state']) ? -1 : 1;
  }  

  function CompareNumberCOST_D($a, $b) 
  {
      if ($a['cost'] == $b['cost']) {
          return 0;
      }
      return ($a['cost'] > $b['cost']) ? -1 : 1;
  }  

  ##############################################################################
  ##                            -                           ##
  ##############################################################################

  class TNumberList
  {
    var $Data = array();
    var $SortType  = 'uin';
    var $SortDirection = 'ascending';
    var $Error = False;
    var $ErrorStr = '';
    var $FileName = '';
    
    function DataLen()
    {
      return count($this->Data);
    } // function DalaLen

    function TNumberList($type, $direction)
    {
      $this->Create($type, $direction);
    } // function TNumberList

    function Create($type, $direction)
    {
      $this->Data = array();
      $this->SortType  = $type;
      $this->SortDirection = $direction;
      $this->Error = False;
    } // function Create

    function Destroy()
    {
      $this->Data = array();
    } // function Destroy

    function LoadFromFile()
    {
      if (!(file_exists($this->FileName)))
      {
        $this->Error = True;
        $this->ErrorStr = '    ';
        if (defined('DEBUG') == True)
        {
          $this->ErrorStr .= '<br/>'.$this->FileName;
        }
        $this->DisplayError();
        exit(0);
      }
      
      $source = file($this->FileName);// or die('       '.$this->FileName);

      $uin = '';
      $state = '';
      $cost = '';
      $number = array();

      $this->Data = array();

      foreach ($source as $v)
      {
        if (strpos($v, ';') === false) continue;
        
        //list($uin, $state, $cost) = explode(';', $v, 3);
        
        if (strpos($v, ';') === false) continue;
        list($uin, $state) = explode(';', $v, 2);
        if (strpos($state, ';') === false) continue;
        list($state, $cost) = explode(';', $state, 2);

        $number = array();
        $number['uin']   = $uin;
        $number['state'] = $state;
        $number['cost']  = $cost;

        $this->Data[] = $number;

        if (defined('DEBUG') == True)
        {
          //echo 'uin: '.$number['uin'].' state: '.$number['state'].' cost: '.$number['cost'].'wmz <br/>';
        }
      }
      unset($source, $v, $uin, $state, $cost, $number);

    } // function LoadFromFile


    function Sort() 
    {
      global $SortDirectionDef, $SortTypeDef;
      
      //$this->SortType = '1342432';
      if (!(in_array($this->SortType, $SortTypeDef)))
      {
        $this->Error = True;
        $this->ErrorStr = '    ';
        $this->DisplayError();
        exit(0);
      }
      
      //$this->SortDirection = '1342432';
      if (!(in_array($this->SortDirection, $SortDirectionDef)))
      {
        $this->Error = True;
        $this->ErrorStr = '   ';
        $this->DisplayError();
        exit(0);
      }
     
      if ($this->DataLen() < 2) return 0;
      
      switch ($this->SortDirection)
      {
        case 'ascending':
        {
          switch ($this->SortType)
          {
            case 'uin'  : usort($this->Data, 'CompareNumberUIN_A'); break;
            case 'state': usort($this->Data, 'CompareNumberSTATE_A'); break;
            case 'cost' : usort($this->Data, 'CompareNumberCOST_A'); break;
          }
          break;
        }
        case 'descending':
        {
          switch ($this->SortType)
          {
            case 'uin'  : usort($this->Data, 'CompareNumberUIN_D'); break;
            case 'state': usort($this->Data, 'CompareNumberSTATE_D'); break;
            case 'cost' : usort($this->Data, 'CompareNumberCOST_D'); break;
          }
          break;
        }
      }    
            
    } // function Sort() 
    
    function DisplayError()
    {
      echo '<b>:</b><br/>'.$this->ErrorStr;
    } // function DisplayError

    function Display()
    {
      $this->Sort();
      
      echo '<hr/>';
      echo '<b> : </b> '.$this->DataLen().'<br/>';
      echo '<hr/>';
      echo "<form name=\"sortparams\" action=\"?\" method=\"get\"><b> </b><br/>";
      
      if ($this->SortType === 'uin')
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"uin\" checked />&nbsp; <br/>";
      }
      else
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"uin\"/>&nbsp; <br/>";
      }
      if ($this->SortType === 'state')
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"state\" checked />&nbsp; <br/>";
      }
      else
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"state\"/>&nbsp; <br/>";
      }
      if ($this->SortType === 'cost')
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"cost\" checked />&nbsp; <br/>";
      }
      else
      {
        echo "<input type=\"radio\" name=\"sort\" value=\"cost\"/>&nbsp; <br/>";
      }

      
      echo '<br/><b> </b><br/>';
      
      
      if ($this->SortDirection === 'ascending')
      {
        echo "<input type=\"radio\" name=\"direction\" value=\"ascending\" checked/>&nbsp; <br/>";
      }
      else
      {
        echo "<input type=\"radio\" name=\"direction\" value=\"ascending\"/>&nbsp; <br/>";
      }
      if ($this->SortDirection === 'descending')
      {
        echo "<input type=\"radio\" name=\"direction\" value=\"descending\" checked/>&nbsp; <br/>";
      }
      else
      {
        echo "<input type=\"radio\" name=\"direction\" value=\"descending\"/>&nbsp; <br/>";
      }

      echo "<input type=\"submit\" name=\"go\" value=\"\"/></form>";
      echo '<hr/>';
      echo '<table border=\"1\">';
      echo '<tr><td width=\"100\"><b>uin:</b></td><td width=\"50\"><b>state:</b></td><td width=\"70\"><b>cost:</b></td></tr>';
      foreach ($this->Data as $number)
      {
        echo '<tr> <td>'.$number['uin'].
             '</td><td>'.$number['state'].
             '</td><td>'.$number['cost'].
             'wmz </td></tr>';
      }
      unset($k, $v);
      echo '</table>';
      echo '<hr/>';

    } //function Display

  } // class TNumberList

?>